;defines
; DISPLAY LIST EQUATES
; 
ADLI        equ $0080
AVB         equ $0040
ALMS        equ $0040
AVSCR       equ $0020
AHSCR       equ $0010
AJMP        equ $0001
AEMPTY1     equ $0000
AEMPTY2     equ $0010
AEMPTY3     equ $0020
AEMPTY4     equ $0030
AEMPTY5     equ $0040
AEMPTY6     equ $0050
AEMPTY7     equ $0060
AEMPTY8     equ $0070

HSCROL      equ $D404
VVBLKI      equ $0222
COLOR1      equ $02C5
COLOR2      equ $02C6
SDLSTL      equ $0230
SDLSTH      equ $0231
CONSOL      equ $D01F
WSYNC       equ $D40A
VCOUNT      equ $D40B
COLPF2      equ $D018


	org $8150
L8150 ins "gremlpic8150.bin"

	org $2000
fnt ins "greml.fnt"
start

L6000       lda #$0C               ; A9 0C
            sta COLOR1             ; 8D C5 02
;setup dist
            lda #<L6069 ; $69               ; A9 69
            sta SDLSTL             ; 8D 30 02
            lda #>L6069 ; $60               ; A9 60
            sta SDLSTH             ; 8D 31 02

            lda #<L602E ; $2E               ; A9 2E
            sta VVBLKI             ; 8D 22 02
            lda #>L602E ; $60               ; A9 60
            sta VVBLKI+1           ; 8D 23 02

            lda L612B              ; AD 2B 61
            inc L612B              ; EE 2B 61
            sta L688D              ; 8D 8D 68
            lda L612B+1 ; L612C              ; AD 2C 61
            sta L688E              ; 8D 8E 68
 ;           jsr L7000              ; 20 00 70
            jmp L688F              ; 4C 8F 68
;602e
L602E
            dec L0600              ; CE 00 06
            lda L0600              ; AD 00 06
            bmi L603C              ; 30 06
            sta HSCROL             ; 8D 04 D4
            jmp L6066              ; 4C 66 60
L603C       lda #$07               ; A9 07
            sta L0600              ; 8D 00 06
            sta HSCROL             ; 8D 04 D4
            inc L612B              ; EE 2B 61
            bne L604C              ; D0 03
            inc L612B+1 ; L612C              ; EE 2C 61
L604C       lda L612B+1 ; L612C              ; AD 2C 61
            cmp #>L6845 ; $68               ; C9 68
            bne L6066              ; D0 13
            lda L612B              ; AD 2B 61
            cmp #<L6845 ; $45               ; C9 45
            bne L6066              ; D0 0C
            lda L688D              ; AD 8D 68
            sta L612B              ; 8D 2B 61
            lda L688E              ; AD 8E 68
            sta L612B+1 ; L612C              ; msb text
L6066       jmp $C0E2              ; 4C E2 C0

L6069       dta AEMPTY8
            dta AEMPTY8
            dta ALMS+$0F
            dta a(L8150)
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F
            dta ALMS+$0F
            dta a(L8150+$EB0) ;L9000)
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
            dta $0F,$0F,$0F,$0F
            dta AHSCR+ALMS+$07
L612B       dta a(L6130)
            dta AVB+AJMP
            dta a(L6069)

L6130       dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$A8,$A9
            dta $81,$00,$B7,$A5,$AC,$A3,$AF,$AD
            dta $A5,$00,$B4,$AF,$00,$B4,$A8,$A5
            dta $00,$A7,$B2,$A5,$AD,$AC,$A9,$AE
            dta $00,$A4,$A5,$AD,$AF,$8C,$00,$B7
            dta $A8,$A9,$A3,$A8,$00,$A9,$B3,$00
            dta $B4,$A8,$A5,$00,$A6,$A9,$B2,$B3
            dta $B4,$00,$A4,$A5,$AD,$AF,$00,$A6
            dta $B2,$AF,$AD,$00,$B4,$A8,$A5,$00
            dta $A4,$B2,$A5,$A1,$AD,$00,$B4,$A5
            dta $A1,$AD,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$A6,$A9
            dta $B2,$B3,$B4,$00,$AF,$A6,$00,$A1
            dta $AC,$AC,$8C,$00,$AC,$A5,$B4,$B3
            dta $00,$A9,$AE,$B4,$B2,$AF,$A4,$B5
            dta $A3,$A5,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$B4,$A8
            dta $A5,$00,$A4,$B2,$A5,$A1,$AD,$00
            dta $B4,$A5,$A1,$AD,$00,$A3,$AF,$B5
            dta $AE,$B4,$B3,$00,$B4,$A8,$B2,$A5
            dta $A5,$00,$AD,$A5,$AD,$A2,$A5,$B2
            dta $B3,$9A,$00,$00,$00,$00,$00,$00
            dta $00,$00,$AD,$A9,$AE,$A4,$A2,$A5
            dta $AE,$A4,$A5,$B2,$8C,$00,$A8,$AF
            dta $B4,$00,$B3,$B4,$A5,$A5,$AC,$00
            dta $A1,$AE,$A4,$00,$AD,$A5,$8C,$00
            dta $B4,$A8,$A5,$00,$B5,$AE,$AB,$AE
            dta $AF,$B7,$AE,$00,$A2,$A1,$B3,$A5
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$AD,$A9,$AE,$A4
            dta $A2,$A5,$AE,$A4,$A5,$B2,$00,$A8
            dta $A1,$B3,$00,$AD,$A1,$A4,$A5,$00
            dta $B3,$AF,$AD,$A5,$00,$A7,$B2,$A5
            dta $A1,$B4,$00,$B0,$A9,$A3,$B4,$B5
            dta $B2,$A5,$B3,$00,$B7,$A9,$B4,$A8
            dta $00,$B8,$AC,$8D,$A1,$B2,$B4,$00
            dta $88,$A9,$00,$A8,$AF,$B0,$A5,$00
            dta $A8,$A5,$00,$A9,$B3,$00,$A7,$A5
            dta $B4,$B4,$A9,$AE,$A7,$00,$A8,$A9
            dta $B3,$00,$B3,$AF,$B5,$AE,$A4,$A4
            dta $A9,$A7,$A9,$B4,$A9,$BA,$A5,$B2
            dta $00,$B3,$AF,$AF,$AE,$81,$89,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$A8,$AF,$B4,$00,$B3
            dta $B4,$A5,$A5,$AC,$00,$A9,$B3,$00
            dta $AC,$A5,$A1,$B2,$AE,$A9,$AE,$A7
            dta $00,$A1,$B3,$B3,$A5,$AD,$A2,$AC
            dta $A5,$B2,$00,$88,$AB,$A5,$A5,$B0
            dta $00,$AC,$A5,$A1,$B2,$AE,$A9,$AE
            dta $A7,$00,$A8,$B3,$81,$00,$A9,$B4
            dta $00,$AB,$A5,$A5,$B0,$B3,$00,$B9
            dta $AF,$B5,$B2,$00,$A2,$B2,$A1,$A9
            dta $AE,$00,$A9,$AE,$00,$A7,$AF,$AF
            dta $A4,$00,$A3,$AF,$AE,$A4,$A9,$B4
            dta $A9,$AF,$AE,$81,$89,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$B4,$A8,$A5,$00,$B5,$AE,$AB
            dta $AE,$AF,$B7,$AE,$00,$A2,$A1,$B3
            dta $A5,$00,$88,$B4,$A8,$A1,$B4,$B3
            dta $00,$AD,$A5,$89,$00,$A9,$B3,$00
            dta $B3,$B4,$A9,$AC,$AC,$00,$AB,$A5
            dta $A5,$B0,$A9,$AE,$A7,$00,$B4,$B2
            dta $A1,$A3,$AB,$00,$AF,$A6,$00,$A8
            dta $A9,$B3,$00,$A5,$A9,$A7,$A8,$B4
            dta $00,$A2,$A9,$B4,$00,$A3,$AF,$AD
            dta $B0,$B5,$B4,$A5,$B2,$00,$88,$A9
            dta $00,$B4,$A8,$A9,$AE,$AB,$00,$A9
            dta $00,$A1,$AD,$00,$A1,$B4,$A1,$B2
            dta $A9,$00,$A3,$B2,$A1,$BA,$B9,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$A9,$00,$AF,$B7,$AE
            dta $00,$A6,$AF,$B5,$B2,$00,$A1,$B4
            dta $A1,$B2,$A9,$B3,$9A,$00,$98,$90
            dta $90,$B8,$AC,$8C,$00,$91,$93,$90
            dta $B8,$A5,$8C,$00,$B0,$A3,$93,$00
            dta $A1,$AE,$A4,$00,$B4,$A8,$A5,$00
            dta $A7,$B2,$A5,$A1,$B4,$00,$91,$90
            dta $94,$90,$B3,$B4,$A5,$81,$89,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$AC,$A5,$B4,$B3,$00
            dta $A7,$A9,$B6,$A5,$00,$B3,$AF,$AD
            dta $A5,$00,$A9,$AE,$A6,$AF,$00,$A1
            dta $A2,$AF,$B5,$B4,$00,$B4,$A8,$A9
            dta $B3,$00,$AC,$A9,$B4,$B4,$AC,$A5
            dta $00,$A4,$A5,$AD,$AF,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$B4,$A8,$A5,$00,$B0,$A9,$A3
            dta $B4,$B5,$B2,$A5,$00,$B7,$A1,$B3
            dta $00,$B3,$A3,$A1,$AE,$AE,$A5,$A4
            dta $00,$A9,$AE,$00,$A5,$A7,$A1,$00
            dta $AF,$AE,$00,$B4,$A8,$A5,$00,$B0
            dta $A3,$00,$88,$B5,$B3,$A9,$AE,$A7
            dta $00,$B4,$A8,$A5,$00,$A7,$A5,$AE
            dta $A9,$B5,$B3,$00,$A8,$A1,$AE,$A4
            dta $B9,$00,$B3,$A3,$A1,$AE,$AE,$A5
            dta $B2,$89,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$A9,$00
            dta $A8,$A1,$A4,$00,$B4,$AF,$00,$B4
            dta $A1,$AB,$A5,$00,$B3,$AF,$AD,$A5
            dta $00,$B0,$A1,$B2,$B4,$B3,$00,$AF
            dta $A6,$A6,$00,$B4,$A8,$A5,$00,$B3
            dta $A3,$B2,$A5,$A5,$AE,$00,$B4,$AF
            dta $00,$AC,$A5,$B4,$00,$A9,$B4,$00
            dta $A6,$A9,$B4,$00,$AF,$AE,$00,$B4
            dta $A8,$A5,$00,$A5,$A9,$A7,$A8,$B4
            dta $00,$A2,$A9,$B4,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $A9,$00,$AD,$A1,$A4,$A5,$00,$A1
            dta $00,$A7,$B2,$A1,$B0,$A8,$A9,$A3
            dta $B3,$00,$A3,$AF,$AE,$B6,$A5,$B2
            dta $B4,$A5,$B2,$00,$A9,$AE,$00,$A7
            dta $B7,$8D,$A2,$A1,$B3,$A9,$A3,$00
            dta $88,$B9,$AF,$81,$89,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$A2,$B9,$00,$B5,$B3,$A9,$AE
            dta $A7,$00,$AD,$B9,$00,$A8,$A1,$B0
            dta $B0,$B9,$00,$91,$90,$95,$90,$00
            dta $A4,$B2,$A9,$B6,$A5,$00,$A9,$00
            dta $A3,$AF,$B5,$AC,$A4,$00,$B2,$A5
            dta $A1,$A4,$00,$B4,$A8,$A5,$00,$AD
            dta $B3,$A4,$AF,$B3,$8D,$A4,$A9,$B3
            dta $AB,$00,$B7,$A9,$B4,$A8,$00,$B4
            dta $A8,$A5,$00,$B0,$A9,$A3,$B4,$B5
            dta $B2,$A5,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$B4,$A8
            dta $A5,$00,$AD,$B5,$B3,$A9,$A3,$00
            dta $A9,$B3,$00,$A6,$B2,$AF,$AD,$00
            dta $A2,$AC,$A1,$A3,$AB,$00,$AC,$A1
            dta $AD,$B0,$8C,$00,$A1,$00,$A7,$B2
            dta $A5,$A1,$B4,$00,$A7,$A1,$AD,$A5
            dta $00,$88,$A9,$00,$B4,$A8,$A9,$AE
            dta $AB,$00,$AF,$AE,$A5,$00,$AF,$A6
            dta $00,$B4,$A8,$A5,$00,$A2,$A5,$B3
            dta $B4,$81,$89,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$B7
            dta $A5,$AC,$AC,$8C,$00,$B4,$A8,$A1
            dta $B4,$B3,$00,$A1,$A2,$AF,$B5,$B4
            dta $00,$A1,$AC,$AC,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $A9
L6601       dta $00,$A1,$AD,$00,$AC,$AF,$AF,$AB
            dta $A9,$AE,$A7,$00,$A6,$AF,$B2,$B7
            dta $A1,$B2,$A4,$00,$B4,$AF,$00,$B3
            dta $A8,$A1,$A4,$AF,$B7,$00,$AF,$A6
            dta $00,$B4,$A8,$A5,$00,$A2,$A5,$A1
            dta $B3,$B4,$00,$AF,$AE,$00,$B4,$A8
            dta $A5,$00,$A5,$A9,$A7,$A8,$B4,$00
            dta $A2,$A9,$B4,$00,$88,$B9,$AF,$B5
            dta $00,$A4,$AF,$00,$AE,$AF,$B4,$00
            dta $A8,$A1,$B6,$A5,$00,$B4,$AF,$00
            dta $A2,$B5,$B9,$00,$A1,$AE,$00,$A1
            dta $AD,$A9,$A7,$A1,$00,$A6,$AF,$B2
            dta $00,$A8,$A1,$B6,$A9,$AE,$A7,$00
            dta $A9,$B4,$81,$89,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $A9,$00,$A8,$AF,$B0,$A5,$00,$AD
            dta $A9,$AE,$A4,$A2,$A5,$AE,$A4,$A5
            dta $B2,$00,$A1,$AE,$A4,$00,$A8,$AF
            dta $B4,$00,$B3,$B4,$A5,$A5,$AC,$00
            dta $B7,$A9,$AC,$AC,$00,$B3,$AF,$AF
            dta $AE,$00,$A2,$A5,$00,$B2,$A5,$A1
            dta $A4,$B9,$00,$A6,$AF,$B2,$00,$AD
            dta $A1,$AB,$A9,$AE,$A7,$00,$A1,$00
            dta $A2,$A9,$A7,$00,$A4,$A5,$AD,$AF
            dta $00,$88,$B9,$AF,$00,$A7,$B5,$B9
            dta $B3,$8C,$00,$A1,$AE,$B9,$00,$A9
            dta $A4,$A5,$A1,$B3,$00,$A1,$B2,$A5
            dta $00,$B7,$A5,$AC,$A3,$AF,$AD,$A5
            dta $81,$89,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$B3,$AF
            dta $AD,$A5,$00,$A7,$B2,$A5,$A5,$B4
            dta $A9,$AE,$A7,$B3,$00,$A9,$8E,$AE
            dta $8E,$B3,$8E,$AF,$8E,$00,$9A,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$AD,$A9,$AE,$A4,$A2,$A5,$AE
            dta $A4,$A5,$B2,$00,$86,$00,$A8,$AF
            dta $B4,$00,$B3,$B4,$A5,$A5,$AC,$00
            dta $88,$B3,$A5,$A5,$00,$B9,$A1,$00
            dta $B3,$AF,$AF,$AE,$81,$89,$8C,$00
            dta $B3,$B4,$AF,$B2,$AD,$B4,$B2,$AF
            dta $AF,$B0,$A5,$B2,$00,$88,$A8,$B4
            dta $B4,$89,$8C,$00,$B0,$B2,$A9,$BA
            dta $AD,$00,$88,$A8,$B4,$B4,$89,$8C
            dta $00,$A1,$AC,$AC,$00,$AF,$B4,$A8
            dta $A5,$B2,$00,$A7,$B5,$B9,$B3,$00
            dta $A6,$B2,$AF,$AD,$00,$B4,$A8,$A5
            dta $00,$A8,$B4,$B4,$81,$8C,$00,$B4
            dta $A7,$A3,$00,$88,$A4,$A1,$B3,$00
            dta $AF,$AD,$A5,$AE,$00,$A9,$B3,$00
            dta $A6,$A1,$AE,$B4,$A1,$B3,$B4,$A9
            dta $A3,$81,$89,$8C,$00,$A8,$B7,$A1
            dta $AD,$00,$88,$B3,$B4,$81,$89,$8C
            dta $00,$B3,$A3,$A1,$AE,$AD,$A1,$AE
            dta $00,$88,$B0,$A3,$89,$8C,$00,$B2
            dta $AF,$B6,$A5,$B9,$00,$88,$B0,$A3
            dta $89,$8C,$00,$A1,$A3,$A5,$00,$AD
            dta $B3,$B4,$00,$88,$B3,$B4,$A9,$AC
            dta $AC,$00,$A2,$B5,$B3,$B3,$B9,$00
            dta $AF,$AE,$00,$B4,$A8,$A5,$00,$B0
            dta $A3,$89,$8C,$00,$A1,$AC,$AC,$00
            dta $AF,$B4,$A8,$A5,$B2,$00,$A1,$B4
            dta $A1,$B2,$A9,$00,$A6,$B2,$A5,$A1
            dta $AB,$B3,$81,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$A5
            dta $AE,$AA,$AF,$B9,$00,$B9,$AF,$B5
            dta $B2,$B3,$A5,$AC,$A6,$B3,$00,$A1
            dta $AE,$A4,$00,$B4,$A9,$AC,$AC,$00
            dta $AE,$A5,$B8,$B4,$00,$B4,$A9,$AD
            dta $A5,$81,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00 ; ,$00,$00
L6845
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00,$00,$00,$00,$00
            dta $00,$00,$00,$00
L688D       dta $00
L688E       dta $00
L688F       lda #$00               ; A9 00
            sta COLOR2             ; 8D C6 02
            ldx #$D1               ; A2 D1
            lda CONSOL             ; AD 1F D0
            cmp #$06               ; C9 06
            beq L68B2              ; F0 15
L689D       lda VCOUNT             ; AD 0B D4
            cmp #$69               ; C9 69
            bne L689D              ; D0 F9
L68A4       sta WSYNC              ; 8D 0A D4
            stx COLPF2             ; 8E 18 D0
            inx                    ; E8
            bne L68A4              ; D0 F7
            stx COLPF2             ; 8E 18 D0
            beq L688F              ; F0 DD
L68B2       inc COLOR1             ; EE C5 02
            jmp L688F              ; 4C 8F 68
L0600 dta 0
	run start